/* Fichier JS du script lecompteestbon */

// Execute l'operation ope sur les plaques numero p1 et p2 de jeu et met a jour le nouveau jeu 
function tour(jeu, p1, p2, ope) {
    if (jeu.tours.length==0) { // On prend les plaques du départ
       var plaques=jeu.tirages;
       var indices=jeu.indices;
    } else {  // On récupère les plaques du tour précédent
      var plaques=jeu.tours[jeu.tours.length-1].plaques;
       var indices=jeu.tours[jeu.tours.length-1].indices;
    }
    var restes=[], resteIndices=[];
    var v1, v2;
    for (var i=0; i<plaques.length; i++) {
      if ((i==p1)||(i==p2)) {
        if (i==p1) {
          v1=plaques[p1];
        }
        if (i==p2) {
          v2=plaques[p2];
        }
      } else {
        restes.push(plaques[i]);
        resteIndices.push(indices[i]);
      }
    }
    switch (ope) {
      case "+":
        var rst=v1+v2;
        restes.push(rst);
        resteIndices.push(-1);
        break;          
      case "-":
        var rst=Math.abs(v1-v2);
        restes.push(rst);
        resteIndices.push(-1);
        break;          
      case "x":
        var rst=v1*v2;
        restes.push(rst);
        resteIndices.push(-1);
        break;          
      case "/":
        if (v1%v2==0) {
        var rst=v1/v2;
          resteIndices.push(-1);
          restes.push(rst);
        } else if (v2%v1==0) {
        var rst=v2/v1;
          resteIndices.push(-1);
          restes.push(rst);
        }          
        break;
    }
    
  jeu.nbTours++;

    var tour={ 
        p1: p1, 
          p2: p2,
          v1: v1,
          v2: v2, 
          ope:ope,
          rst:rst,
          plaques: restes,
          indices: resteIndices
          
    };
    /* Un tour est composé des numéros de plaques p1 et p2
     de la valeur des plaques v1 et v2 et d'indice i1 et i2 dans le tirage
     de l'opération ope et de son resultat rst
     et enfin du tableau plaques qui reste à utiliser */
    jeu.tours.push(tour);
    
    
  // Si le tour arrive au but, enregistrer la solution qui utilise le moins d'opérations 
    if (rst===jeu.but) {
    
    // Ajout de la nouvelle solution
    jeu.solutions.push(jeu.tours);
    
    // Filtrer les solutions avec moins d'opérations que la solution minimale ou la solution courante
    jeu.solutions=jeu.solutions.filter(t => t.length <= Math.min(jeu.tours.length, jeu.solutions[0].length));
    
    } else {
      // Enregistrer les solutions les plus proches
      
    }

  return rst;
}



/* Fonction récursive pour parcourir les possibilites de réduction du tableau de tirage */
function chercherSolution(jeu, operations="") {
  if (jeu.tours.length==0) {
    var plaques=jeu.tirages;
  } else {
    var plaques=jeu.tours[jeu.tours.length-1].plaques;
  }
  if (plaques.length<=2) { // Il ne reste plus assez de plaques : fin de la recherche
    return true;
  }

  // Tableaux des tours de la solution
  var tours=[];

  // Boucle sur la première plaque du calcul
  for (var p1=0; p1<jeu.tirages.length; p1++) {
    // Boucle sur la seconde plaque (indice p2 de p1+1 a n)
    for (var p2=p1+1; p2<plaques.length; p2++) {
      // Boucle sur les 4 operations
      if (operations=="") {
        operations=jeu.operateurs;
      }
      operations.forEach(function(ope, index) {
        tours[p1+"-"+p2+"-"+index]=JSON.parse(JSON.stringify(jeu.tours));
        // Réduction du tableau des plaques
        if (tour(jeu, p1, p2, ope)!=jeu.but) { /* Fonction de calcul d'une opération */
          // Application de l'opération du tour
          chercherSolution(jeu);  // Appel récursif        
        }
        jeu.tours=tours[p1+"-"+p2+"-"+index];
      });
    }
  }
}

// Vérifier si les tours t1 et t2 sont equivalents
function isTourEquival(t1, t2) {
  if (t1.ope==t2.ope) { // Meme operation 
    if ((t1.v1==t2.v1)&&(t1.v2==t2.v2)) {return true;} // Meme valeur de v1 et v2
    if ((t1.v1==t2.v2)&&(t1.v2==t2.v1)) {return true;} // Meme valeur de v1 et v2 inversée
  }
  return false;
} 

// Verifier que les solutions s1 et s2 sont bien uniques
function isSolutionEquivalente(s1, s2) {
  // Pas meme nombre de tours 
  if (s1.length!=s2.length) { 
    return false;
  }
  // Vérifier si le tour final est semblable entre les deux solutions 
  var n=s1.length;
  if (isTourEquival(s1[n-1], s2[n-1])) {
    return true;
  }
  // Parcourir tous les tours de s1      
  for (var i=0; i<s1.length; i++) {
    var isTrouve=false;
    // Chercher un tour equivalent dans la solution s2
    for (var j=0; j<s2.length; j++) {
      if (isTourEquival(s1[i], s2[j])) {
        isTrouve=true;
        break;    
      }
    }
    if (isTrouve) {
      return true;
    }
  }
  return false;
} 


/* Filtrer les solutions pupprimer les doublons */
function filtrerSolution(jeu) {
  var uniques=[];
  /* Ajouter la 1ere solution d'office*/
  if (jeu.solutions.length==0) {

  } else {
    uniques.push(JSON.parse(JSON.stringify(jeu.solutions[0])));
    // Comparer le reste des solutions
    for (var i=1; i<jeu.solutions.length; i++) {
      // Verifier si la solution est bien nouvelle
      var isNew=true;
      for (var j=0; j<uniques.length; j++) {
        // Si les deux solutions sont équivalentes, on ne l'ajoute pas à uniques
        if (isSolutionEquivalente(jeu.solutions[i], uniques[j])) { 
          isNew=false;
          break;
        }
      }
      if (isNew) {
        uniques.push(JSON.parse(JSON.stringify(jeu.solutions[i])));
      }
    }
  }
  jeu.uniques=uniques;
}



var jeu={};
onmessage=function(evenement) {
  jeu=evenement.data;
  console.time("Traitements worker thread #"+jeu.numThread);
  var dt=new Date();
  jeu.start=dt.getTime();
  chercherSolution(jeu, jeu.threadOperateurs);  
  filtrerSolution(jeu);
  console.timeEnd("Traitements worker thread #"+jeu.numThread);
  var dt=new Date();
  jeu.end=dt.getTime();
  postMessage(jeu);
}